package com.css.simulation.resource.scheduler.service;

import api.common.util.FileUtil;
import api.common.util.HttpUtil;
import com.css.simulation.resource.scheduler.configuration.custom.CustomConfiguration;
import com.css.simulation.resource.scheduler.configuration.kubernetes.KubernetesConfiguration;
import com.css.simulation.resource.scheduler.data.model.NodeModel;
import lombok.SneakyThrows;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.File;
import java.util.List;

@Service
public class FileService {
    @Resource
    KubernetesConfiguration kubernetesConfiguration;
    @Resource
    CustomConfiguration customConfiguration;

    @SneakyThrows
    public void uploadOsgb(MultipartFile file) {
        final String targetFilePath = customConfiguration.getTemporaryDirectory() + "/esmini-osgb";
        FileUtil.writeInputStreamToLocalFile(file.getInputStream(), targetFilePath);
        final List<NodeModel> nodeModels = kubernetesConfiguration.getCpuNodeList();
        nodeModels.forEach(nodeModel -> HttpUtil.post(customConfiguration.getUploadOsgbUrl().replace("simulation-resource-video", nodeModel.getIp()), new File(targetFilePath)));
    }
}
